#include <stdlib.h>
#include <iostream>
using namespace std;

#include <snbfrx.h>
using namespace snbfrx;

#include "simpleentity.h"

// call the entity constructor
SimpleEntity::SimpleEntity( int id, EntityFactory* pfactory ):Entity( pfactory )
{
    // set up the id
    m_id = id;

    // set up health
    reset();
}

SimpleEntity::~SimpleEntity()
{

}

void SimpleEntity::reset()
{
    // assign a random value for the health.
    m_health = rand() & 0xFF;
}

bool SimpleEntity::update()
{

    // decrease health point each update.
    m_health --;

    // if health is less or equal to zero, then entity is dead.
    if( m_health <= 0 )
        cout << "SimpleEntity::update() -- entity(" << m_id << ") has died." << endl;

    return m_health > 0;
}

void SimpleEntity::render()
{
    // render entity status.
    cout << "SimpleEntity::render() -- entity(" << m_id << ") is still alive with ";
    cout << m_health << " health left." << endl;
    
}
